package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;


/**
 * 实体[User] 数据对象
 */
@TableName(value = "T_SRFUSER",resultMap = "UserResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class User extends EntityBase implements Serializable{

    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    @TableLogic(value= "1",delval="0")//设定逻辑有效属性
    @TableField(fill = FieldFill.INSERT)
    private Integer enable;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer issystem;
    private String loginname;
    private String loginpwd;
    @TableField(exist = false)//逻辑属性
    private String memo;
    @TableField(exist = false)//逻辑属性
    private String ownerid;
    @TableField(exist = false)//逻辑属性
    private String ownertype;
    private String reserver;
    private String reserver2;
    @TableField(exist = false)//逻辑属性
    private String subtype;
    @Dict(dictName = "ionicdemo_CodeList59CodeList")
    private String timezone;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    @TableField(exist = false)//逻辑属性
    private String userdata;
    @TableField(exist = false)//逻辑属性
    private String userdata2;
    @TableId(value= "userid",type=IdType.UUID)//指定主键生成策略
    private String userid;
    private String usermode;
    private String username;
    @TableField(exist = false)//逻辑属性
    private Integer userobjectlevel;
    @TableField(exist = false)//逻辑属性
    @Dict(dictName = "ionicdemo_CodeList5CodeList")
    private String userobjecttype;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer validflag;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[逻辑有效标志]
     *  @param enable
     */
    public void setEnable(Integer enable){
        this.enable = enable;
        this.set("enabledirtyflag",true);
    }
    /**
     *  获取属性值[逻辑有效标志]
     */
    public Integer getEnable(){
        if(StringUtils.isEmpty(enable))
        {
            this.enable = 1;//设置逻辑有效值
            this.set("enabledirtyflag",true);
        }
        return this.enable;
    }
    /**
     *  重置属性值[逻辑有效标志]
     */
    public void resetEnable(){
        this.set("enabledirtyflag",false);
        this.enable = null;
    }
    /**
     *  设置属性值[系统数据]
     *  @param issystem
     */
    public void setIssystem(Integer issystem){
        this.issystem = issystem;
        this.set("issystemdirtyflag",true);
    }
    /**
     *  获取属性值[系统数据]
     */
    public Integer getIssystem(){
        return this.issystem;
    }
    /**
     *  重置属性值[系统数据]
     */
    public void resetIssystem(){
        this.set("issystemdirtyflag",false);
        this.issystem = null;
    }
    /**
     *  设置属性值[登录名称]
     *  @param loginname
     */
    public void setLoginname(String loginname){
        if(StringUtils.isEmpty(loginname))
            loginname=null;
        this.loginname = loginname;
        this.set("loginnamedirtyflag",true);
    }
    /**
     *  获取属性值[登录名称]
     */
    public String getLoginname(){
        return this.loginname;
    }
    /**
     *  重置属性值[登录名称]
     */
    public void resetLoginname(){
        this.set("loginnamedirtyflag",false);
        this.loginname = null;
    }
    /**
     *  设置属性值[登录密码]
     *  @param loginpwd
     */
    public void setLoginpwd(String loginpwd){
        if(StringUtils.isEmpty(loginpwd))
            loginpwd=null;
        this.loginpwd = loginpwd;
        this.set("loginpwddirtyflag",true);
    }
    /**
     *  获取属性值[登录密码]
     */
    public String getLoginpwd(){
        return this.loginpwd;
    }
    /**
     *  重置属性值[登录密码]
     */
    public void resetLoginpwd(){
        this.set("loginpwddirtyflag",false);
        this.loginpwd = null;
    }
    /**
     *  设置属性值[备注]
     *  @param memo
     */
    public void setMemo(String memo){
        if(StringUtils.isEmpty(memo))
            memo=null;
        this.memo = memo;
        this.set("memodirtyflag",true);
    }
    /**
     *  获取属性值[备注]
     */
    public String getMemo(){
        return this.memo;
    }
    /**
     *  重置属性值[备注]
     */
    public void resetMemo(){
        this.set("memodirtyflag",false);
        this.memo = null;
    }
    /**
     *  设置属性值[所有者标识]
     *  @param ownerid
     */
    public void setOwnerid(String ownerid){
        if(StringUtils.isEmpty(ownerid))
            ownerid=null;
        this.ownerid = ownerid;
        this.set("owneriddirtyflag",true);
    }
    /**
     *  获取属性值[所有者标识]
     */
    public String getOwnerid(){
        return this.ownerid;
    }
    /**
     *  重置属性值[所有者标识]
     */
    public void resetOwnerid(){
        this.set("owneriddirtyflag",false);
        this.ownerid = null;
    }
    /**
     *  设置属性值[所有者类型]
     *  @param ownertype
     */
    public void setOwnertype(String ownertype){
        if(StringUtils.isEmpty(ownertype))
            ownertype=null;
        this.ownertype = ownertype;
        this.set("ownertypedirtyflag",true);
    }
    /**
     *  获取属性值[所有者类型]
     */
    public String getOwnertype(){
        return this.ownertype;
    }
    /**
     *  重置属性值[所有者类型]
     */
    public void resetOwnertype(){
        this.set("ownertypedirtyflag",false);
        this.ownertype = null;
    }
    /**
     *  设置属性值[保留字段]
     *  @param reserver
     */
    public void setReserver(String reserver){
        if(StringUtils.isEmpty(reserver))
            reserver=null;
        this.reserver = reserver;
        this.set("reserverdirtyflag",true);
    }
    /**
     *  获取属性值[保留字段]
     */
    public String getReserver(){
        return this.reserver;
    }
    /**
     *  重置属性值[保留字段]
     */
    public void resetReserver(){
        this.set("reserverdirtyflag",false);
        this.reserver = null;
    }
    /**
     *  设置属性值[保留字段2]
     *  @param reserver2
     */
    public void setReserver2(String reserver2){
        if(StringUtils.isEmpty(reserver2))
            reserver2=null;
        this.reserver2 = reserver2;
        this.set("reserver2dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段2]
     */
    public String getReserver2(){
        return this.reserver2;
    }
    /**
     *  重置属性值[保留字段2]
     */
    public void resetReserver2(){
        this.set("reserver2dirtyflag",false);
        this.reserver2 = null;
    }
    /**
     *  设置属性值[子类型]
     *  @param subtype
     */
    public void setSubtype(String subtype){
        if(StringUtils.isEmpty(subtype))
            subtype=null;
        this.subtype = subtype;
        this.set("subtypedirtyflag",true);
    }
    /**
     *  获取属性值[子类型]
     */
    public String getSubtype(){
        return this.subtype;
    }
    /**
     *  重置属性值[子类型]
     */
    public void resetSubtype(){
        this.set("subtypedirtyflag",false);
        this.subtype = null;
    }
    /**
     *  设置属性值[所在时区]
     *  @param timezone
     */
    public void setTimezone(String timezone){
        if(StringUtils.isEmpty(timezone))
            timezone=null;
        this.timezone = timezone;
        this.set("timezonedirtyflag",true);
    }
    /**
     *  获取属性值[所在时区]
     */
    public String getTimezone(){
        return this.timezone;
    }
    /**
     *  重置属性值[所在时区]
     */
    public void resetTimezone(){
        this.set("timezonedirtyflag",false);
        this.timezone = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[自定义数据]
     *  @param userdata
     */
    public void setUserdata(String userdata){
        if(StringUtils.isEmpty(userdata))
            userdata=null;
        this.userdata = userdata;
        this.set("userdatadirtyflag",true);
    }
    /**
     *  获取属性值[自定义数据]
     */
    public String getUserdata(){
        return this.userdata;
    }
    /**
     *  重置属性值[自定义数据]
     */
    public void resetUserdata(){
        this.set("userdatadirtyflag",false);
        this.userdata = null;
    }
    /**
     *  设置属性值[自定义数据2]
     *  @param userdata2
     */
    public void setUserdata2(String userdata2){
        if(StringUtils.isEmpty(userdata2))
            userdata2=null;
        this.userdata2 = userdata2;
        this.set("userdata2dirtyflag",true);
    }
    /**
     *  获取属性值[自定义数据2]
     */
    public String getUserdata2(){
        return this.userdata2;
    }
    /**
     *  重置属性值[自定义数据2]
     */
    public void resetUserdata2(){
        this.set("userdata2dirtyflag",false);
        this.userdata2 = null;
    }
    /**
     *  设置属性值[用户标识]
     *  @param userid
     */
    public void setUserid(String userid){
        if(StringUtils.isEmpty(userid))
            userid=null;
        this.userid = userid;
        this.set("useriddirtyflag",true);
    }
    /**
     *  获取属性值[用户标识]
     */
    public String getUserid(){
        return this.userid;
    }
    /**
     *  重置属性值[用户标识]
     */
    public void resetUserid(){
        this.set("useriddirtyflag",false);
        this.userid = null;
    }
    /**
     *  设置属性值[用户模式]
     *  @param usermode
     */
    public void setUsermode(String usermode){
        if(StringUtils.isEmpty(usermode))
            usermode=null;
        this.usermode = usermode;
        this.set("usermodedirtyflag",true);
    }
    /**
     *  获取属性值[用户模式]
     */
    public String getUsermode(){
        return this.usermode;
    }
    /**
     *  重置属性值[用户模式]
     */
    public void resetUsermode(){
        this.set("usermodedirtyflag",false);
        this.usermode = null;
    }
    /**
     *  设置属性值[用户名称]
     *  @param username
     */
    public void setUsername(String username){
        if(StringUtils.isEmpty(username))
            username=null;
        this.username = username;
        this.set("usernamedirtyflag",true);
    }
    /**
     *  获取属性值[用户名称]
     */
    public String getUsername(){
        return this.username;
    }
    /**
     *  重置属性值[用户名称]
     */
    public void resetUsername(){
        this.set("usernamedirtyflag",false);
        this.username = null;
    }
    /**
     *  设置属性值[用户对象级别]
     *  @param userobjectlevel
     */
    public void setUserobjectlevel(Integer userobjectlevel){
        this.userobjectlevel = userobjectlevel;
        this.set("userobjectleveldirtyflag",true);
    }
    /**
     *  获取属性值[用户对象级别]
     */
    public Integer getUserobjectlevel(){
        return this.userobjectlevel;
    }
    /**
     *  重置属性值[用户对象级别]
     */
    public void resetUserobjectlevel(){
        this.set("userobjectleveldirtyflag",false);
        this.userobjectlevel = null;
    }
    /**
     *  设置属性值[用户对象类型]
     *  @param userobjecttype
     */
    public void setUserobjecttype(String userobjecttype){
        if(StringUtils.isEmpty(userobjecttype))
            userobjecttype=null;
        this.userobjecttype = userobjecttype;
        this.set("userobjecttypedirtyflag",true);
    }
    /**
     *  获取属性值[用户对象类型]
     */
    public String getUserobjecttype(){
        return this.userobjecttype;
    }
    /**
     *  重置属性值[用户对象类型]
     */
    public void resetUserobjecttype(){
        this.set("userobjecttypedirtyflag",false);
        this.userobjecttype = null;
    }
    /**
     *  设置属性值[是否启用]
     *  @param validflag
     */
    public void setValidflag(Integer validflag){
        this.validflag = validflag;
        this.set("validflagdirtyflag",true);
    }
    /**
     *  获取属性值[是否启用]
     */
    public Integer getValidflag(){
        return this.validflag;
    }
    /**
     *  重置属性值[是否启用]
     */
    public void resetValidflag(){
        this.set("validflagdirtyflag",false);
        this.validflag = null;
    }
    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetEnable();
        resetIssystem();
        resetLoginname();
        resetLoginpwd();
        resetMemo();
        resetOwnerid();
        resetOwnertype();
        resetReserver();
        resetReserver2();
        resetSubtype();
        resetTimezone();
        resetUpdatedate();
        resetUpdateman();
        resetUserdata();
        resetUserdata2();
        resetUserid();
        resetUsermode();
        resetUsername();
        resetUserobjectlevel();
        resetUserobjecttype();
        resetValidflag();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public User copyTo(User targetEntity)
	{
		BeanCopier copier=BeanCopier.create(User.class, User.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetUserid();
		return targetEntity;
	}
}